/* Copyright 2007, Unpublished Work of Technologic Systems
 * All Rights Reserved.
 *
 * THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
 * PROPRIETARY AND TRADE SECRET INFORMATION OF TECHNOLOGIC SYSTEMS.
 * ACCESS TO THIS WORK IS RESTRICTED TO (I) TECHNOLOGIC SYSTEMS 
 * EMPLOYEES WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE
 * OF THEIR ASSIGNMENTS AND (II) ENTITIES OTHER THAN TECHNOLOGIC
 * SYSTEMS WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.  NO
 * PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED, 
 * DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED, 
 * EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED, ADAPTED
 * IN ANY FORM OR BY ANY MEANS, MANUAL, MECHANICAL, CHEMICAL, 
 * ELECTRICAL, ELECTRONIC, OPTICAL, BIOLOGICAL, OR OTHERWISE WITHOUT
 * THE PRIOR WRITTEN PERMISSION AND CONSENT OF TECHNOLOGIC SYSTEMS.
 * ANY USE OR EXPLOITATION OF THIS WORK WITHOUT THE PRIOR WRITTEN
 * CONSENT OF TECHNOLOGIC SYSTEMS COULD SUBJECT THE PERPETRATOR TO
 * CRIMINAL AND CIVIL LIABILITY.
 */

module wb_isabridge(
	wb_clk_i,
	wb_rst_i,
	
	wbs_cyc_i,
	wbs_stb_i,
	wbs_we_i,
	wbs_adr_i,
	wbs_dat_i,
	wbs_dat_o,
	wbs_ack_o,
	wbs_sel_i,
	
	isa_dat_i,
	isa_dat_o,
	isa_dat_oe_o,
	isa_add_o,
	isa_memr_o,
	isa_memw_o,
	isa_ior_o,
	isa_iow_o,
	isa_iordy_i,
);

endmodule


module wb_isabridge_full(
  wb_clk_i,
  wb_rst_i,

  wbs1_cyc_i,
  wbs1_stb_i,
  wbs1_adr_i,
  wbs1_we_i,
  wbs1_dat_i,
  wbs1_dat_o,
  wbs1_sel_i,
  wbs1_ack_o,

  wbs2_cyc_i,
  wbs2_stb_i,
  wbs2_adr_i,
  wbs2_we_i,
  wbs2_dat_i,
  wbs2_dat_o,
  wbs2_sel_i,
  wbs2_ack_o,

  wbs3_cyc_i,
  wbs3_stb_i,
  wbs3_adr_i,
  wbs3_we_i,
  wbs3_dat_i,
  wbs3_dat_o,
  wbs3_sel_i,
  wbs3_ack_o,

  wbs4_cyc_i,
  wbs4_stb_i,
  wbs4_adr_i,
  wbs4_we_i,
  wbs4_dat_i,
  wbs4_dat_o,
  wbs4_sel_i,
  wbs4_ack_o,

  iospace1_i,   /* wb_tga[] address tags */
  strobelen1_i,
  setuplen1_i,
  iospace2_i,
  strobelen2_i,
  setuplen2_i,
  iospace3_i,
  strobelen3_i,
  setuplen3_i,
  iospace4_i,
  strobelen4_i,
  setuplen4_i,

  isa_sa_o,
  isa_sa_i,
  isa_sa_oe_o,
  isa_la_o,
  isa_la_i,
  isa_la_oe_o,
  isa_sd_i,
  isa_sd_o,
  isa_sd_oe_o,
  isa_iochrdy_i,
  isa_reset_o,
  isa_memr_o,
  isa_memr_i,
  isa_memr_oe_o,
  isa_memw_o,
  isa_memw_i,
  isa_memw_oe_o,
  isa_smemr_o,
  isa_smemw_o,
  isa_ior_o,
  isa_ior_i,
  isa_ior_oe_o,
  isa_iow_o,
  isa_iow_i,
  isa_iow_oe_o,
  isa_osc_o,
  isa_sbhe_o,
  isa_sbhe_i,
  isa_sbhe_oe_o,
  isa_iocs16_i,
  isa_memcs16_i,
  isa_endx_i,
  isa_bale_o,
  isa_aen_o,
  isa_refresh_o,
  isa_bclk_o,
  isa_dack0_o,
  isa_dack1_o,
  isa_dack2_o,
  isa_dack3_o,
  isa_dack5_o,
  isa_dack6_o,
  isa_dack7_o,
  isa_drq0_i,
  isa_drq1_i,
  isa_drq2_i,
  isa_drq3_i,
  isa_drq5_i,
  isa_drq6_i,
  isa_drq7_i,
  isa_tc_i,
  isa_tc_o,
  isa_tc_oe_o,
  isa_master_i,
  isa_iochck_i

);

input wb_clk_i, wb_rst_i;

input wbs1_cyc_i, wbs1_stb_i, wbs1_we_i;
input [3:0] wbs1_sel_i;
input [31:0] wbs1_adr_i, wbs1_dat_i;
output [31:0] wbs1_dat_o;
output wbs1_ack_o;
input iospace1_i;
input [5:0] strobelen1_i;
input [5:0] setuplen1_i;

input wbs2_cyc_i, wbs2_stb_i, wbs2_we_i;
input [3:0] wbs2_sel_i;
input [31:0] wbs2_adr_i, wbs2_dat_i;
output [31:0] wbs2_dat_o;
output wbs2_ack_o;
input iospace2_i;
input [5:0] strobelen2_i;
input [5:0] setuplen2_i;

input wbs3_cyc_i, wbs3_stb_i, wbs3_we_i;
input [3:0] wbs3_sel_i;
input [31:0] wbs3_adr_i, wbs3_dat_i;
output [31:0] wbs3_dat_o;
output wbs3_ack_o;
input iospace3_i;
input [5:0] strobelen3_i;
input [5:0] setuplen3_i;

input wbs4_cyc_i, wbs4_stb_i, wbs4_we_i;
input [3:0] wbs4_sel_i;
input [31:0] wbs4_adr_i, wbs4_dat_i;
output [31:0] wbs4_dat_o;
output wbs4_ack_o;
input iospace4_i;
input [5:0] strobelen4_i;
input [5:0] setuplen4_i;

output [23:0] isa_sa_o, isa_sa_oe_o;
output [23:17] isa_la_o, isa_la_oe_o;
input [23:17] isa_la_i;
input [23:0] isa_sa_i;
output [15:0] isa_sd_o, isa_sd_oe_o;
input [15:0] isa_sd_i;
output isa_reset_o, isa_memr_o, isa_memw_o, isa_ior_o, isa_iow_o;
output isa_memr_oe_o, isa_memw_oe_o, isa_ior_oe_o, isa_iow_oe_o;
output isa_sbhe_oe_o;
input isa_memr_i, isa_memw_i, isa_ior_i, isa_iow_i, isa_sbhe_i;
output isa_osc_o, isa_sbhe_o, isa_smemr_o, isa_smemw_o;
input isa_iochrdy_i, isa_iocs16_i, isa_memcs16_i, isa_endx_i;
output isa_bale_o, isa_aen_o, isa_tc_o, isa_tc_oe_o;
output isa_refresh_o, isa_bclk_o, isa_dack0_o, isa_dack1_o;
output isa_dack2_o, isa_dack3_o, isa_dack5_o, isa_dack6_o, isa_dack7_o;
input isa_drq0_i, isa_drq1_i, isa_drq2_i, isa_drq3_i, isa_iochck_i;
input isa_drq5_i, isa_drq6_i, isa_drq7_i, isa_tc_i, isa_master_i;


wire [31:0] wb_adr_i;
wire [31:0] wb_dat_i;
wire [3:0] wb_sel_i;
wire [31:0] wb_dat_o;
wire wb_ack_o, wb_cyc_i, wb_stb_i, wb_we_i;
wire [1:0] wbowner;
wb_arbiter arbitercore(
  .wb_clk_i(wb_clk_i),

  .wbowner_dat_o(wb_dat_i),
  .wbowner_dat_i(wb_dat_o),
  .wbowner_adr_o(wb_adr_i),
  .wbowner_cyc_o(wb_cyc_i),
  .wbowner_stb_o(wb_stb_i),
  .wbowner_we_o(wb_we_i),
  .wbowner_ack_i(wb_ack_o),
  .wbowner_sel_o(wb_sel_i),

  .wb1_adr_i(wbs1_adr_i),
  .wb1_dat_i(wbs1_dat_i),
  .wb1_dat_o(wbs1_dat_o),
  .wb1_cyc_i(wbs1_cyc_i),
  .wb1_stb_i(wbs1_stb_i),
  .wb1_we_i(wbs1_we_i),
  .wb1_ack_o(wbs1_ack_o),
  .wb1_sel_i(wbs1_sel_i),

  .wb2_adr_i(wbs2_adr_i),
  .wb2_dat_i(wbs2_dat_i),
  .wb2_dat_o(wbs2_dat_o),
  .wb2_cyc_i(wbs2_cyc_i),
  .wb2_stb_i(wbs2_stb_i),
  .wb2_we_i(wbs2_we_i),
  .wb2_ack_o(wbs2_ack_o),
  .wb2_sel_i(wbs2_sel_i),

  .wb3_adr_i(wbs3_adr_i),
  .wb3_dat_i(wbs3_dat_i),
  .wb3_dat_o(wbs3_dat_o),
  .wb3_cyc_i(wbs3_cyc_i),
  .wb3_stb_i(wbs3_stb_i),
  .wb3_we_i(wbs3_we_i),
  .wb3_ack_o(wbs3_ack_o),
  .wb3_sel_i(wbs3_sel_i),

  .wb4_adr_i(wbs4_adr_i),
  .wb4_dat_i(wbs4_dat_i),
  .wb4_dat_o(wbs4_dat_o),
  .wb4_cyc_i(wbs4_cyc_i),
  .wb4_stb_i(wbs4_stb_i),
  .wb4_we_i(wbs4_we_i),
  .wb4_ack_o(wbs4_ack_o),
  .wb4_sel_i(wbs4_sel_i),

  .wbowner_o(wbowner)
);

assign isa_la_oe_o = {7{1'b1}};
assign isa_sa_oe_o = {24{1'b1}};
assign isa_ior_oe_o = 1'b1;
assign isa_iow_oe_o = 1'b1;
assign isa_memr_oe_o = 1'b1;
assign isa_memw_oe_o = 1'b1;
assign isa_sbhe_oe_o = 1'b1;
assign isa_refresh_o = 1'b1;
assign isa_dack0_o = 1'b1;
assign isa_dack1_o = 1'b1;
assign isa_dack2_o = 1'b1;
assign isa_dack3_o = 1'b1;
assign isa_dack5_o = 1'b1;
assign isa_dack6_o = 1'b1;
assign isa_dack7_o = 1'b1;
assign isa_reset_o = wb_rst_i;
assign isa_aen_o = 1'b0;
assign isa_tc_oe_o = 1'b0;
assign isa_tc_o = 1'b1;

reg [5:0] strobelen;
reg iospace;
reg [5:0] setuplen;

always @(wbowner) begin
  case (wbowner)
  2'd0: begin
    strobelen = strobelen1_i;
    iospace = iospace1_i;
    setuplen = setuplen1_i;
  end
  2'd1: begin
    strobelen = strobelen2_i;
    iospace = iospace2_i;
    setuplen = setuplen2_i;
  end
  2'd2: begin
    strobelen = strobelen3_i;
    iospace = iospace3_i;
    setuplen = setuplen3_i;
  end
  2'd3: begin
    strobelen = strobelen4_i;
    iospace = iospace4_i;
    setuplen = setuplen4_i;
  end
  endcase
end

reg [2:0] state;
reg [5:0] count;
reg [23:0] adr;
reg [1:0] byte_adr;
reg sbhe, sbhe_q;
reg [3:0] done, pending;
reg [15:0] dat, dat_q;
reg [31:0] dat_o;
reg dat_oe;
reg isa_iochrdy, wb_ack;
reg isa_iow, isa_ior, isa_memr, isa_memw;
assign isa_iow_o = !isa_iow;
assign isa_memw_o = !isa_memw;
assign isa_smemw_o = !(isa_memw && (isa_sa_o <= 20'hfffff));
assign isa_smemr_o = !(isa_memr && (isa_sa_o <= 20'hfffff));
assign isa_ior_o = !isa_ior;
assign isa_memr_o = !isa_memr;
assign isa_sd_oe_o = {16{dat_oe}};
assign isa_sd_o = dat_q;
assign isa_sa_o = adr;
assign isa_la_o = adr[23:17];
assign isa_sbhe_o = !sbhe_q; /* active-low */
assign wb_ack_o = wb_ack;
assign wb_dat_o = dat_o;
wire io_en = iospace;
wire isa_16_en = (io_en ? !isa_iocs16_i : !isa_memcs16_i);

always @(wb_sel_i or done or isa_16_en or wb_dat_i) begin
  case (wb_sel_i & ~done)
  4'b0011, 4'b0111, 4'b1011, 4'b1111, 4'b0000: begin
    byte_adr = 2'd0;
    sbhe = 1'b1;
    dat = wb_dat_i[15:0];
    pending = isa_16_en ? 4'b0011 : 4'b0001;
  end
  4'b0001, 4'b0101, 4'b1001, 4'b1101: begin
    byte_adr = 2'd0;
    sbhe = 1'b0;
    dat = {8'hxx, wb_dat_i[7:0]}; 
    pending = 4'b0001;
  end
  4'b0010, 4'b0110, 4'b1010, 4'b1110: begin
    byte_adr = 2'd1;
    sbhe = 1'b1;
    dat = {wb_dat_i[15:8], wb_dat_i[15:8]};
    pending = 4'b0010;
  end
  4'b1100: begin
    byte_adr = 2'd2;
    sbhe = 1'b1;
    dat = wb_dat_i[31:16];
    pending = isa_16_en ? 4'b1100 : 4'b0100;
  end
  4'b0100: begin
    byte_adr = 2'd2;
    sbhe = 1'b0;
    dat = {8'hxx, wb_dat_i[23:16]};
    pending = 4'b0100;
  end
  4'b1000: begin
    byte_adr = 2'd3;
    sbhe = 1'b1;
    dat = {wb_dat_i[31:24], wb_dat_i[31:24]};
    pending = 4'b1000;
  end
  endcase
end


reg [2:0] osc_state;
reg [3:0] bclk_state;
reg osc, bclk;
assign isa_osc_o = osc;
assign isa_bclk_o = bclk;
always @(posedge wb_clk_i) begin
  if (osc_state == 3'd6) osc_state <= 3'd0;
  else osc_state <= osc_state + 1'b1;

  if (osc_state >= 3'd3) osc <= 1'b1;
  else osc <= 1'b0;

  if (bclk_state == 4'd9) bclk_state <= 4'd0;
  else bclk_state <= bclk_state + 1'b1;

  if (bclk_state >= 4'd4) bclk <= 1'b1;
  else bclk <= 1'b0;
end

reg bale, isa_0ws;
assign isa_bale_o = bale;
always @(posedge wb_clk_i or posedge wb_rst_i) begin
  if (wb_rst_i) begin
    bale <= 1'b0;
    state <= 3'd0;
    count <= 6'd0;
    done <= 4'd0;
    isa_memr <= 1'b0;
    isa_memw <= 1'b0;
    isa_ior <= 1'b0;
    isa_iow <= 1'b0;
    isa_iochrdy <= 1'b0;
    sbhe_q <= 1'b0;
    adr <= 22'd0;
    dat_oe <= 1'b0;
    dat_q <= 16'd0;
    wb_ack <= 1'b0;
    isa_0ws <= 1'b0;
  end else begin
    isa_iochrdy <= isa_iochrdy_i;
    isa_0ws <= !isa_endx_i;
    case (state) 
    3'd0: begin
      if (wb_cyc_i && wb_stb_i) begin
        adr[23:2] <= wb_adr_i[23:2];
        adr[1:0] <= byte_adr;
        bale <= 1'b1;
        sbhe_q <= sbhe;
        dat_q <= dat;
        dat_oe <= wb_we_i;
        state <= 3'd1;
      end else begin
        dat_oe <= 1'b0;
        done <= 4'd0;
      end
    end
    3'd1: begin
      if (count >= setuplen) begin
        state <= 3'd2;
        count <= 6'd0;
      end else count <= count + 1'b1;
    end
    3'd2: begin 
      bale <= 1'b0;
      case ({io_en, wb_we_i})
      2'b00: isa_memr <= 1'b1;
      2'b01: isa_memw <= 1'b1;
      2'b10: isa_ior <= 1'b1;
      2'b11: isa_iow <= 1'b1;
      endcase
      if ((count > strobelen) || isa_0ws) begin
        if (isa_iochrdy) state <= 3'd3;
      end else count <= count + 1'b1;
    end
    3'd3: begin
      count <= 6'd0;
      isa_memr <= 1'b0;
      isa_memw <= 1'b0;
      isa_ior <= 1'b0;
      isa_iow <= 1'b0;
      case (pending)
      4'b0001, 4'b0101, 4'b1001,
      4'b1101, 4'b0000: dat_o[7:0] <= isa_sd_i[7:0];
      4'b0011, 4'b0111, 4'b1011, 4'b1111: dat_o[15:0] <= isa_sd_i[15:0];
      4'b0010, 4'b0110, 4'b1010, 4'b1110: begin
        if (isa_16_en) dat_o[15:8] <= isa_sd_i[15:8];
        else dat_o[15:8] <= isa_sd_i[7:0];
      end
      4'b0100: dat_o[23:16] <= isa_sd_i[7:0];
      4'b1100: dat_o[31:16] <= isa_sd_i[15:0];
      4'b1000: begin
        if (isa_16_en) dat_o[31:24] <= isa_sd_i[15:8];
        else dat_o[31:24] <= isa_sd_i[7:0];
      end
      endcase
      done <= done | pending;
      if ((done | pending) == wb_sel_i) wb_ack <= 1'b1;
      state <= 3'd4;
    end
    3'd4: begin
      if (wb_ack) done <= 4'd0;
      wb_ack <= 1'b0;
      state <= 3'd0;
    end
    endcase
  end
end
endmodule

